#ifndef UBL_UTILS
#define UBL_UTILS
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <pthread.h>
#include <string.h>
#include <dirent.h>
#include <locale.h>
#include <gtk/gtk.h>
#include <gtk/gtkx.h>
#include <vte/vte.h>
#include <pwd.h>
#include <stdbool.h>
#include "ubl-cmake.h"
#ifdef WEBKIT_FOUND
    #include <webkit2/webkit2.h>
#endif 
#define DesktopPath "/usr/share/applications/"

#define for_dictionaries(obj, obj1) for (obj = obj1->first; obj != NULL; obj = obj->next)

#define new(type) malloc(sizeof(type))
#define new_arr(type,size) malloc(sizeof(type)*size)

#define yon_ubl_set_config_save_data_pointer(command) config_commands.config_save_data = command

#define yon_ubl_load_global_config(command, size_pointer) yon_config_load(command, size_pointer)
#define yon_ubl_load_local_config(command, size_pointer) yon_config_load(command, size_pointer)
#define yon_ubl_save_global_config(command) yon_config_save(command)
#define yon_ubl_save_local_config(command) yon_config_save(command)

#define try bool __HadError=false;
#define catch(x) ExitJmp:if(__HadError)
#define throw(x) {__HadError=true;goto ExitJmp;}
#define file_source_login_min_max "/etc/login.defs"

typedef enum
{
    #ifdef __GTK_H__
    DICTIONARY_GTK_WIDGETS_TYPE,
    #endif
    DICTIONARY_OTHER_TYPE

} DICT_TYPE;

typedef struct
{
    char *command;
    int *exitcode;
} thread_output;


typedef struct dictionary
{
    char *key;
    void *data;
    struct dictionary *next;
    struct dictionary *prev;
    struct dictionary *first;
    DICT_TYPE data_type;
} dictionary;

typedef struct apps
{
    char *Name;
    int Type;
    char *Categories;
    char *Exec;
    char *Icon;
    int Pluggable;
    int DualPluggable;
} apps;

typedef char** config_str;
// dictionary functions

/**yon_dictionary_get_data(dictionary, type)
 * [EN]
 * Gets data from dictionary.
 * [dictionary] is dictionary, from which data should be extracted;
 * [type] is type of data, [dictionary] contains.
 * [RU]
 * Возвращает данные из словаря.
 * [dictionary] - словарь из которого достаются данные.
 * [type] - тип данных, хранящихся в словаре [dictionary].
*/
#define yon_dictionary_get_data(dictionary, type) ((type)dictionary->data)
#define yon_dictionary_add_or_create_if_exists_with_data(dict,key,data) {if (!dict) dict=yon_dictionary_create_with_data(key,data); \
                                                                        else dict=yon_dictionary_create_with_data_connected(dict,key,data);}

dictionary *yon_dictionary_create_empty();

dictionary *yon_dictionary_create_conneced(dictionary *targetdict);

dictionary *yon_dictionary_get_last(dictionary *dict);

dictionary *yon_dictionary_switch_places(dictionary *dict, int aim);

void yon_dictionary_make_first(dictionary *dict);

void yon_dictionary_make_nth(dictionary *dict, int nth);

dictionary *yon_dictionary_create_with_data(char *key, void *data);

dictionary *yon_dictionary_create_with_data_connected(dictionary *dict, char *key, void *data);

dictionary *yon_dictionary_connect(dictionary *old, dictionary *toconnect);

dictionary *yon_dictionary_find(dictionary **dict, char *key);

dictionary *yon_dictionary_rip(dictionary *dict);

dictionary *yon_dictionary_get_nth(dictionary *dict, int place);

void *yon_dictionary_free_all(dictionary *dictionary,void (data_manipulation)(void*));

// char functions
char* philos_str_remove(char *str, const char *sub);
char *yon_char_get_augumented(char *source, char *append);

char *yon_char_new(char *chr);

char *yon_char_unite(char *source, ...);

char *yon_cut(char *source, int size, int startpos);

char *yon_char_divide(char *source, int dividepos);

char *yon_char_divide_search(char *source, char *dividepos, int delete_divider);

char *yon_char_from_int(int int_to_convert);

char *yon_char_replace(char *source, char *find, char*replace);

void philos_split_size_memory(char* str_value, int* size, char* pow_memory);

char **yon_char_parse(char *parameters, int *size, char *divider);

char** philos_str_split(char *parameters, int *size, char *divider);

char **yon_char_parsed_shrink(char **char_string, int *size, int item_to_delete);

int yon_char_parsed_check_exist(char **parameters, int size, char *param);

int yon_char_find_count(char *source, char *find);

int yon_char_parsed_includes_char_parsed (config_str source, config_str to_check, int source_size, int check_size);

config_str yon_char_parsed_new (config_str old, int *old_size, ...);
config_str yon_char_parsed_append(config_str parsed, int *size, char *string);
// parsing functions

config_str philos_list_user(int* size);

char* philos_str_size_pow_byte(GtkWidget *combo_box_text);

config_str philos_list_group(int* size);

unsigned short philos_read_uid_min_max(char* filename, char* search);

apps *yon_apps_scan_and_parse_desktops(int *sizef);

void yon_apps_sort(apps *applist, int size);

apps *yon_apps_get_by_name(apps *applist, char *name, int size);

config_str yon_config_load(char *command, int *str_len);

int yon_config_save(char *command);

char *yon_config_get_parameter(config_str parameters, int size, char *param);

char *yon_config_make_save_parameter_with_multiple_arguments(char *parameter_string, char *config_parameter, char *divider);

// terminal-using functions

int yon_launch_app(char *name);

int yon_launch_app_with_arguments(char *name, char *args);

int yon_launch(thread_output *thread);

int* philos_int_append(int* array, int* size, int value);

int* remove_element_int_array(int* array, int* size, int index);
// Gtk functions

#ifdef __GTK_H__
#ifdef VTE_TERMINAL

/**
 * 
*/
void yon_terminal_integrated_launch(GtkWidget *terminal, char* command, void *endwork_function, void* endwork_function_argument);
char* philos_get_size_bite(GtkWidget* chk_button, GtkWidget* spin, GtkWidget* combo_box_text);
void philos_fill_combo_box_text(GtkWidget *cbt, config_str list_data, int size);
#endif

/**yon_gtk_builder_get_widget(builder, widget_name)
 * [EN]
 * Returns GtkWidget from GtkBuilder *[builder].
 * [builder] is GtkBuilder*;
 * [widget_name] is id of widget;
*/
#define yon_gtk_builder_get_widget(builder, widget_name) GTK_WIDGET(gtk_builder_get_object(builder, widget_name))

typedef struct
{
    GtkWidget *Icon;
    GtkWidget *Label;
    GtkWidget *IconView;
    GtkListStore *List;
} expander_icon_view;

// GtkWidget *yon_gtk_app_chooser_apps_create();

// dictionary *yon_gtk_app_chooser_create();

// expander_icon_view yon_gtk_icon_view_expander_create(GtkWidget *pack, ...);

int yon_gtk_combo_box_fill(GtkWidget *combo, char **parameters,int size);

int yon_gtk_combo_box_text_find(GtkWidget *combo_box, char *text_to_find);

int yon_gtk_icon_view_hide_empty(dictionary *icon_view_segment);

int yon_dictionary_gtk_pack_start_multiple_widgets(dictionary *dict, GtkWidget *destination, gboolean expand, gboolean fill, int padding);
int yon_dictionary_gtk_pack_end_multiple_widgets(dictionary *dict, GtkWidget *destination, gboolean expand, gboolean fill, int padding);



typedef enum
{
    BACKGROUND_IMAGE_SUCCESS_TYPE,
    BACKGROUND_IMAGE_FAIL_TYPE
} BACKGROUND_IMAGE_TYPE;

typedef struct {
    BACKGROUND_IMAGE_TYPE type;
    GtkWidget *icon;
    GtkWidget *box;
    GtkWidget *label;
    char* text_to_render;
} render_data;


/**yon_ubl_status_box_setup(render,icon,box,label)
 * [EN]
 * Sets up [render] structure of type render_data.
 * [icon] is GtkImage widget of status box for showing status icons;
 * [box] is GtkBox widget of status box for showing status color;
 * [label] is GtkLabel widget of status box for showing status text;
 * [RU]
 * Настраивает структуру [render] типа render_data.
 * [icon] - виджет типа GtkIcon в котором будут отображаться статусные иконки;
 * [box] - виджет типа GtkBox в котором будет отображаться цвет статуса;
 * [label] - виджет типа GtkLabel в котором будет отображаться текст статусного сообщения;
*/
int yon_ubl_status_box_setup(GtkWidget *icon, GtkWidget *box, GtkWidget *label);

/**yon_ubl_status_box_render(render,text,type)
 * [EN]
 * Renders message in status box;
 * [render] is render_data structure of status box;
 * [text] is text to be shown in status box;
 * [type] if type of message. Can be BACKGROUND_IMAGE_FAIL_TYPE or BACKGROUND_IMAGE_SUCCESS_TYPE
 * [RU]
 * Отображает сообщение в статусном окне.
 * [render] - структура типа render_data для нужного статусного окна;
 * [text] - текст, отображаемый в статусном окне;
 * [type] - тип сообщения. Может быть:
 * BACKGROUND_IMAGE_FAIL_TYPE (красный фон,иконка - восклицательный знак)
 * или
 * BACKGROUND_IMAGE_SUCCESS_TYPE (Жёлтный фон, иконка - галка)
*/
void yon_ubl_status_box_render(char *text, BACKGROUND_IMAGE_TYPE type);

#ifdef __cplusplus

/**yon_ubl_header_setup(overlay, head, image, imag_path)
 * [EN]
 * Sets up header of app.
 * [overlay] is overlay for app header;
 * [head] is box of header, which connects to [overlay]
 * [image] is header background image;
 * [imag_path] is path of image, shown in [image] 
 * [RU]
 * Настраивает заголовок приложения.
 * [overlay] - оверлей заголовка приложения;
 * [head] - шапка заголовка, присоединяемая к [overlay]
 * [image] - виджет картинки для заднего фона;
 * [imag_path] - путь до картинки, загружаемой в [image] 
*/
#define yon_ubl_header_setup(overlay, head, image, imag_path) _yon_ubl_header_setup(GTK_WIDGET(overlay.gobj()), GTK_WIDGET(head.gobj()), GTK_WIDGET(image.gobj()), (char *)imag_path)
#else

/**yon_ubl_header_setup(overlay, head, image, imag_path)
 * [EN]
 * Sets up header of app.
 * [overlay] is overlay for app header;
 * [head] is box of header, which connects to [overlay]
 * [image] is header background image;
 * [imag_path] is path of image, shown in [image] 
 * [RU]
 * Настраивает заголовок приложения.
 * [overlay] - оверлей заголовка приложения;
 * [head] - шапка заголовка, присоединяемая к [overlay]
 * [image] - виджет картинки для заднего фона;
 * [imag_path] - путь до картинки, загружаемой в [image] 
*/
#define yon_ubl_header_setup(overlay, head, image, imag_path) _yon_ubl_header_setup(GTK_WIDGET(overlay), GTK_WIDGET(head), GTK_WIDGET(image), (char *)imag_path)
#endif

void _yon_ubl_header_setup(GtkWidget *Overlay, GtkWidget *Head, GtkWidget *Image, char *image_path);

void yon_ubl_setup_sockets(GtkWidget *main_window, GtkWidget *left_window, GtkWidget *right_window, int socket_main_id, int socket_left_id, int socket_right_id);
#ifdef WEBKIT_FOUND

void yon_ubl_browser_window_open(char *link, char *browser_window_name);
#else
void yon_ubl_browser_window_open(char *link,  char *browser_window_name);
#endif
#endif
#endif