#include "view_add.h"

add_window *add_widgets = NULL;


add_window *add_setup_window(char* glade_path) {
    if (add_widgets == NULL) {
        add_widgets = malloc(sizeof(add_window));
        GtkBuilder *builder = gtk_builder_new_from_file(glade_path);
        add_widgets->Window = yon_gtk_builder_get_widget(builder,"wndQuotasAdding");
        add_widgets->btnSaveAddSave = yon_gtk_builder_get_widget(builder,"btnSaveAddSave");
        add_widgets->btnAddCancel = yon_gtk_builder_get_widget(builder,"btnAddCancel");

        add_widgets->entryAddCmd = yon_gtk_builder_get_widget(builder,"entryAddCmd");
        add_widgets->cbxAddQuotaObj = yon_gtk_builder_get_widget(builder,"cbxAddQuotaObj");
        add_widgets->cbxAddQuotaLevel2 = yon_gtk_builder_get_widget(builder,"cbxAddQuotaLevel2");
        add_widgets->cbtAddDevice = yon_gtk_builder_get_widget(builder,"cbtAddDevice");
        add_widgets->lblCPULimitAdd = yon_gtk_builder_get_widget(builder,"lblCPULimitAdd");
        add_widgets->spinCPULimitAdd = yon_gtk_builder_get_widget(builder,"spinCPULimitAdd");
        add_widgets->chkCPULimitAdd = yon_gtk_builder_get_widget(builder,"chkCPULimitAdd");       
        
        add_widgets->chkPaddingFLAdd = yon_gtk_builder_get_widget(builder,"chkPaddingFLAdd");
        add_widgets->spinPaddingFLAdd = yon_gtk_builder_get_widget(builder,"spinPaddingFLAdd");
        add_widgets->cmbPaddingFLAdd = yon_gtk_builder_get_widget(builder,"cmbPaddingFLAdd"); 

        add_widgets->chkSevereRestrictionAdd = yon_gtk_builder_get_widget(builder,"chkSevereRestrictionAdd");
        add_widgets->spinSevereRestrictionAdd = yon_gtk_builder_get_widget(builder,"spinSevereRestrictionAdd");
        add_widgets->cmbSevereRestrictionAdd = yon_gtk_builder_get_widget(builder,"cmbSevereRestrictionAdd"); 
        
        add_widgets->chkSoftRestrictionAdd = yon_gtk_builder_get_widget(builder,"chkSoftRestrictionAdd");
        add_widgets->spiSevereRestrictionAdd = yon_gtk_builder_get_widget(builder,"spiSevereRestrictionAdd");
        add_widgets->cmSevereRestrictionAdd = yon_gtk_builder_get_widget(builder,"cmSevereRestrictionAdd"); 

        add_widgets->chbAddRead = yon_gtk_builder_get_widget(builder,"chbAddRead");
        add_widgets->spinAddRead = yon_gtk_builder_get_widget(builder,"spinAddRead");
        add_widgets->cbtAddRead = yon_gtk_builder_get_widget(builder,"cbtAddRead"); 

        add_widgets->spinAddWrite = yon_gtk_builder_get_widget(builder,"spinAddWrite");
        add_widgets->chbAddWrite = yon_gtk_builder_get_widget(builder,"chbAddWrite");
        add_widgets->cbtAddWrite = yon_gtk_builder_get_widget(builder,"cbtAddWrite"); 
        
        device_fill_disk(add_widgets->cbtAddDevice);
        add_event(add_widgets);
        add_init_windows();
        add_localization(add_widgets);
    }
    
    return add_widgets;
}

void add_init_windows() {
    add_set_active_widgets(add_widgets->chkSoftRestrictionAdd, add_widgets->spiSevereRestrictionAdd, add_widgets->cmSevereRestrictionAdd);
    add_set_active_widgets(add_widgets->chkSevereRestrictionAdd, add_widgets->spinSevereRestrictionAdd, add_widgets->cmbSevereRestrictionAdd);
    add_set_active_widgets(add_widgets->chkPaddingFLAdd, add_widgets->spinPaddingFLAdd, add_widgets->cmbPaddingFLAdd);
    add_set_active_widgets(add_widgets->chkCPULimitAdd, add_widgets->spinCPULimitAdd, add_widgets->lblCPULimitAdd);
    add_set_active_widgets(add_widgets->chbAddWrite, add_widgets->spinAddWrite, add_widgets->cbtAddWrite);
    add_set_active_widgets(add_widgets->chbAddRead, add_widgets->spinAddRead, add_widgets->cbtAddRead);
    add_generate_cmd();
}

void add_event(add_window *widgets) {
    g_signal_connect(G_OBJECT(widgets->btnAddCancel),"clicked",G_CALLBACK(add_on_destroy_subwindow),NULL);
    g_signal_connect(G_OBJECT(widgets->Window), "destroy", G_CALLBACK(add_destroy), NULL);
    g_signal_connect(G_OBJECT(widgets->chkSoftRestrictionAdd), "toggled", G_CALLBACK(add_init_windows), NULL);
    g_signal_connect(G_OBJECT(widgets->chkSevereRestrictionAdd), "toggled", G_CALLBACK(add_init_windows), NULL);
    g_signal_connect(G_OBJECT(widgets->chkPaddingFLAdd), "toggled", G_CALLBACK(add_init_windows), NULL);
    g_signal_connect(G_OBJECT(widgets->chkCPULimitAdd), "toggled", G_CALLBACK(add_init_windows), NULL);
    g_signal_connect(G_OBJECT(widgets->chbAddRead), "toggled", G_CALLBACK(add_init_windows), NULL);
    g_signal_connect(G_OBJECT(widgets->chbAddWrite), "toggled", G_CALLBACK(add_init_windows), NULL);
    g_signal_connect(G_OBJECT(widgets->cbxAddQuotaObj),"changed",G_CALLBACK(add_update_combo_box), NULL);

    g_signal_connect(G_OBJECT(widgets->spiSevereRestrictionAdd),"value-changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->spinSevereRestrictionAdd),"value-changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->spinPaddingFLAdd),"value-changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->spinCPULimitAdd),"value-changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->spinAddRead),"value-changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->spinAddWrite),"value-changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->cmSevereRestrictionAdd),"changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->cmbSevereRestrictionAdd),"changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->cmbPaddingFLAdd),"changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->cbtAddRead),"changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->cbtAddWrite),"changed",G_CALLBACK(add_generate_cmd), NULL);
    g_signal_connect(G_OBJECT(widgets->cbtAddDevice),"changed",G_CALLBACK(add_generate_cmd), NULL);
    
}   

void add_destroy(GtkWidget *self) {
    add_widgets = NULL;
}

void add_set_active_widgets(GtkWidget *self, GtkWidget *entry, GtkWidget *label) {
    gboolean active = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(self));
    gtk_widget_set_sensitive(entry, active);
    gtk_widget_set_sensitive(label, active);
}

void add_localization(add_window *widgets) {
    
}

void add_on_destroy_subwindow(GtkWidget *self) {
    gtk_widget_destroy(gtk_widget_get_toplevel(self));
    add_widgets = NULL;
    
}

add_window *get_widget_add() {
    return add_widgets;
}

void add_show(GtkWidget *self, char* glade_path) {
    if (add_widgets != NULL) {
        add_update_combo_box();
        gtk_widget_show_all(add_widgets->Window);
        
    }
    else {
        add_setup_window(glade_path);
        add_update_combo_box();
        gtk_widget_show_all(add_widgets->Window);
    }
}

char* add_get_select_device_to_level_2() {
    char* text = gtk_combo_box_text_get_active_text(GTK_COMBO_BOX_TEXT(add_widgets->cbxAddQuotaLevel2));
    if (text != NULL) {
        return text;
    }
    else {
        char* str = (char*)malloc(sizeof(char*)*2);
        str[0] = '-';
        str[1] = '\0';
        return str;
    }
}

char* add_get_select_device() {
    char* text = gtk_combo_box_text_get_active_text(GTK_COMBO_BOX_TEXT(add_widgets->cbtAddDevice));
    if (text != NULL) {
        return text;
    }
    else {
        char* str = (char*)malloc(sizeof(char*)*2);
        str[0] = '-';
        str[1] = '\0';
        return str;
    }
}
int add_get_read_device_size() {
    return gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cbtAddRead));
}
int add_get_write_device_size() {
    return gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cbtAddWrite));
}
int add_get_soft_size() {
    return gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cmSevereRestrictionAdd));
}
int add_get_hard_size() {
    return gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cmbSevereRestrictionAdd));
}
int add_get_limit_cpu_size() {
    return -1;
}
int add_get_limit_swap_size() {
    return gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cmbPaddingFLAdd));
}
int add_get_quota_object_size() {
    return gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cbxAddQuotaObj));
}
char* add_get_read_device() {
    return philos_get_size_bite(add_widgets->chbAddRead, add_widgets->spinAddRead,
        add_widgets->cbtAddRead);
}
char* add_get_write_device() {
    return philos_get_size_bite(add_widgets->chbAddWrite, add_widgets->spinAddWrite,
        add_widgets->cbtAddWrite);
}
char* add_get_soft() {
    return philos_get_size_bite(add_widgets->chkSoftRestrictionAdd, add_widgets->spiSevereRestrictionAdd,
        add_widgets->cmSevereRestrictionAdd);
}
char* add_get_hard() {
    return philos_get_size_bite(add_widgets->chkSevereRestrictionAdd, add_widgets->spinSevereRestrictionAdd,
        add_widgets->cmbSevereRestrictionAdd);
}
char* add_get_limit_cpu() {
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(add_widgets->chkCPULimitAdd))) {
        int size_bite = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(add_widgets->spinCPULimitAdd));
        return yon_char_from_int(size_bite);
    }
    else {
        char* str = (char*)malloc(sizeof(char*)*2);
        str[0] = '-';
        str[1] = '\0';
        return str;
    }
}
char* add_get_limit_swap() {
    return philos_get_size_bite(add_widgets->chkPaddingFLAdd, add_widgets->spinPaddingFLAdd,
        add_widgets->cmbPaddingFLAdd);
}
char* add_get_quota_object() {
    return gtk_combo_box_text_get_active_text(GTK_COMBO_BOX_TEXT(add_widgets->cbxAddQuotaObj));
}
void add_update_combo_box() {
    int menu_id = gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cbxAddQuotaObj));
    char* cmd = NULL;
    config_str fill_cmb_2 = NULL;
    int size = 0;
    if (menu_id == 0) {
        fill_cmb_2 = philos_list_user(&size);

    }
    else if (menu_id == 1) {

    }
    else if (menu_id == 2) {

    }
    else if (menu_id == 3) {

    }
    if (menu_id >= 0) {
        gtk_combo_box_text_remove_all(GTK_COMBO_BOX_TEXT(add_widgets->cbxAddQuotaLevel2));
        philos_fill_combo_box_text(add_widgets->cbxAddQuotaLevel2, fill_cmb_2, size);
        // yon_terminal_integrated_launch(widgets->vteProcesses, cmd, NULL, NULL);
    }
}
void add_generate_cmd() {
    char* str_cmd = "";
    char* split_simvol = g_malloc0(sizeof(char)*2);
    int size_bite = 0;
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(add_widgets->chkSoftRestrictionAdd))) {
        size_bite = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(add_widgets->spiSevereRestrictionAdd));
        str_cmd = yon_char_unite(str_cmd,
                                        "MemoryHigh=",
                                        yon_char_from_int(size_bite),
                                        philos_str_size_pow_byte(add_widgets->cmSevereRestrictionAdd), NULL);
        split_simvol[0] = ',';
        split_simvol[1] = '\0';
    }
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(add_widgets->chkSevereRestrictionAdd))) {
        size_bite = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(add_widgets->spinSevereRestrictionAdd));
        str_cmd = yon_char_unite(str_cmd, split_simvol, 
                                        "MemoryMax=",
                                        yon_char_from_int(size_bite),
                                        philos_str_size_pow_byte(add_widgets->cmbSevereRestrictionAdd), NULL);
        split_simvol[0] = ',';
        split_simvol[1] = '\0';
    }
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(add_widgets->chkPaddingFLAdd))) {
        size_bite = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(add_widgets->spinPaddingFLAdd));
        str_cmd = yon_char_unite(str_cmd, split_simvol, 
                                        "MemorySwapMax=",
                                        yon_char_from_int(size_bite),
                                        philos_str_size_pow_byte(add_widgets->cmbPaddingFLAdd), NULL);
        split_simvol[0] = ',';
        split_simvol[1] = '\0';
    }
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(add_widgets->chkCPULimitAdd))) {
        size_bite = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(add_widgets->spinCPULimitAdd));
        str_cmd = yon_char_unite(str_cmd, split_simvol, 
                                        "CPUQuota=",
                                        yon_char_from_int(size_bite),
                                        "\%", NULL);
        split_simvol[0] = ',';
        split_simvol[1] = '\0';
    }
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(add_widgets->chbAddRead))) {
        int menu_id = gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cbtAddDevice));
        if (menu_id != -1) {
            size_bite = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(add_widgets->spinAddRead));
            str_cmd = yon_char_unite(str_cmd, split_simvol, 
                                        "IOReadBandwidthMax=\"",
                                        get_device_cfg()->name_disk[menu_id],
                                        " ",
                                        yon_char_from_int(size_bite),
                                        philos_str_size_pow_byte(add_widgets->cbtAddRead),"\"", NULL);
        }
        split_simvol[0] = ',';
        split_simvol[1] = '\0';
        
    }
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(add_widgets->chbAddWrite))) {
        int menu_id = gtk_combo_box_get_active(GTK_COMBO_BOX(add_widgets->cbtAddDevice));
        if (menu_id != -1) {
            size_bite = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(add_widgets->spinAddWrite));
            str_cmd = yon_char_unite(str_cmd, split_simvol, 
                                        "IOWriteBandwidthMax=\"",
                                        get_device_cfg()->name_disk[menu_id],
                                        " ",
                                        yon_char_from_int(size_bite),
                                        philos_str_size_pow_byte(add_widgets->cbtAddWrite),"\"", NULL);
        }
    }
    gtk_entry_set_text(GTK_ENTRY(add_widgets->entryAddCmd), str_cmd);
    free(split_simvol);
}
