#ifndef VIEW_EDIT_H
#define VIEW_EDIT_H
#include <gtk/gtk.h>
#include <gtk/gtkx.h>
#include "ubl-utils.h"
#include "ubl-strings.h"
#include <locale.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <libintl.h>
#include <getopt.h>
#include <libintl.h>
#include "my_device.h"

// Переменные
typedef struct {
    GtkWidget* Window;
    GtkWidget* btnSaveEditSave;
    GtkWidget* btnEditCancel;
    
    GtkWidget* entryEditCmd;
    GtkWidget* chbEditRead;
    GtkWidget* spinEditRead;
    GtkWidget* cbtEditRead;

    GtkWidget* chbEditWrite;
    GtkWidget* spinEditWrite;
    GtkWidget* cbtEditWrite;
    
    GtkWidget* chkSoftRestrictionEdit;
    GtkWidget* spiSevereRestrictionEdit;
    GtkWidget* cmSevereRestrictionEdit;
    
    GtkWidget* chkSevereRestrictionEdit;
    GtkWidget* spinSevereRestrictionEdit;
    GtkWidget* cmbSevereRestrictionEdit;

    GtkWidget* chkPaddingFLEdit;
    GtkWidget* spinPaddingFLEdit;
    GtkWidget* cmbPaddingFLEdit;

    GtkWidget* chkCPULimitEdit;
    GtkWidget* spinCPULimitEdit;
    GtkWidget* lblCPULimitEdit;
    GtkWidget* cbtEditDevice;
} edit_window;

// Функции
edit_window *edit_setup_window(char* glade_path);
void edit_event(edit_window *widgets);
void edit_localization(edit_window *widgets);
void edit_on_hide_subwindow(GtkWidget *self);
edit_window *get_widget_edit();
void edit_show(GtkWidget *self, char* glade_path);
void edit_destroy(GtkWidget *self);
void edit_init_windows();
void edit_set_active_widgets(GtkWidget *self, GtkWidget *entry, GtkWidget *label);
char* edit_get_select_device();
char* edit_get_read_device();
char* edit_get_write_device();
char* edit_get_soft();
char* edit_get_hard();
char* edit_get_limit_cpu();
char* edit_get_limit_swap();
void edit_generate_cmd();
void wrapper_edit_show();
void edit_set_select_device(char* str_value, int pow_mem);
void edit_set_read_device(char* str_value, int pow_mem);
void edit_set_write_device(char* str_value, int pow_mem);
void edit_set_soft(char* str_value, int pow_mem);
void edit_set_hard(char* str_value, int pow_mem);
void edit_set_limit_cpu(char* str_value, int pow_mem);
void edit_set_limit_swap(char* str_value, int pow_mem);
void edit_temp_set(char* str_value, int pow_mem, GtkWidget* cheek, GtkWidget* spin, GtkWidget* combo_box_text);

int edit_get_read_device_size();
int edit_get_write_device_size();
int edit_get_soft_size();
int edit_get_hard_size();
int edit_get_limit_cpu_size();
int edit_get_limit_swap_size();
#endif